"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _socket = _interopRequireDefault(require("socket.io-client"));

var _messagesSubscriber = _interopRequireDefault(require("./messages-subscriber.js"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var WebNotify =
/*#__PURE__*/
function () {
  function WebNotify() {
    _classCallCheck(this, WebNotify);

    _defineProperty(this, "state", {});

    _defineProperty(this, "url", null);

    _defineProperty(this, "path", null);

    _defineProperty(this, "name", null);

    this.state = {
      subscribers: {}
    };

    if (!WebNotify.instance) {
      WebNotify.instance = this;
    }

    return WebNotify.instance;
  }

  _createClass(WebNotify, [{
    key: "addSocket",
    value: function addSocket() {
      var url = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
      var path = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      var name = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
      var self = this;
      this.name = name;
      this.broadcast.bind(this);

      if (!url) {
        // eslint-disable-next-line no-restricted-globals
        this.url = location.protocol + '//' + location.host + '/wsock';
        this.path = path || '/apps/stream';
      } else {
        this.url = url;
        this.path = path || '/apps/stream';
      }

      console.log(this.url);
      this.system = _socket["default"].connect(this.url, {
        path: path
      }); // Listen to push notifications

      this.system.on('push', function (msg) {
        self.broadcast(msg.data);
      }); // Listen when push notification is sent and read/display data

      this.system.on('output', function (data) {
        var room = data.room,
            message = data.message;
        console.log(data['room']);
        console.log(data);
        self.broadcast(data.room, message);
      });
    }
  }, {
    key: "broadcast",
    value: function broadcast(room, message) {
      console.log(this.print());

      if (room in this.state['subscribers']) {
        var subscriber = this.state['subscribers'][room];
        console.log(_typeof(subscriber));
        subscriber.broadcastMessage(message);
      } // const { messages } = this.state;
      // let temp = messages;
      // temp.prepend(data);
      // this.setState({
      //   messages: temp
      // });

    }
  }, {
    key: "print",
    value: function print() {
      return JSON.stringify(this.state) + ' ' + this.name;
    }
  }, {
    key: "joinRoom",
    value: function joinRoom(room) {
      var listener = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      console.log('joining room' + room);
      var subscribers = this.state.subscribers;
      var tempSubs = subscribers;
      var newSub = new _messagesSubscriber["default"](room);

      if (listener) {
        newSub.subscribe(listener);
      }

      console.log(tempSubs);
      tempSubs = _objectSpread({}, tempSubs, _defineProperty({}, room, newSub));
      console.log(tempSubs);
      this.state['subscribers'] = tempSubs;
      console.log('new state: ' + this.print());
      this.system.emit('join', {
        room: room
      });
    }
  }, {
    key: "subscribe",
    value: function subscribe(room, listener) {
      var subscribers = this.state.subscribers;
      var tempSubs = subscribers;
      console.log('subscribing ' + listener.room + ' ' + listener);

      if (!(room in tempSubs)) {
        this.joinRoom(room, listener);
      }

      if (room in tempSubs) {
        tempSubs[room].subscribe(listener);
        this.state['subscribers'] = tempSubs;
      }
    }
  }], [{
    key: "getInstance",
    value: function getInstance() {
      if (WebNotify.instance == null) {
        console.log('havent found instance');
        WebNotify.instance = new WebNotify();
      }

      console.log('returning instance');
      return this.instance;
    }
  }]);

  return WebNotify;
}();

_defineProperty(WebNotify, "instance", null);

_defineProperty(WebNotify, "system", null);

var instance = new WebNotify(); // Object.freeze(instance)

var _default = instance;
exports["default"] = _default;
