"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _messageListener = _interopRequireDefault(require("../core/message-listener.js"));

var _react = _interopRequireDefault(require("react"));

var _webNotify = _interopRequireDefault(require("../core/web-notify.js"));

var _axios = _interopRequireDefault(require("axios"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var TestListener =
/*#__PURE__*/
function (_Listener) {
  _inherits(TestListener, _Listener);

  function TestListener() {
    var _this;

    var room = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
    var state = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
    var msgToState = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;

    _classCallCheck(this, TestListener);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(TestListener).call(this));

    _defineProperty(_assertThisInitialized(_this), "room", null);

    _defineProperty(_assertThisInitialized(_this), "state", null);

    _defineProperty(_assertThisInitialized(_this), "msgToState", null);

    _this.messages = [];
    _this.room = room;
    _this.state = state;
    _this.msgToState = msgToState; // console.log("state is: " + state);

    return _this;
  }

  _createClass(TestListener, [{
    key: "onReadMessage",
    value: function onReadMessage(msg) {
      if (typeof msg !== 'undefined') {
        this.messages.push(msg); // console.log(msg)
        // console.log(JSON.stringify(this.state));
        // console.log(this.msgToState);

        if (this.msgToState && this.msgToState !== 'undefined') {
          this.msgToState(msg);
        }

        return msg;
      }
    }
  }]);

  return TestListener;
}(_messageListener["default"]);

var TestPage =
/*#__PURE__*/
function (_React$Component) {
  _inherits(TestPage, _React$Component);

  // = null;
  function TestPage() {
    var _this2;

    _classCallCheck(this, TestPage);

    _this2 = _possibleConstructorReturn(this, _getPrototypeOf(TestPage).call(this));

    _defineProperty(_assertThisInitialized(_this2), "listener", void 0);

    _this2.state = {
      messages: []
    };
    _this2.msgToState = _this2.msgToState.bind(_assertThisInitialized(_this2));
    _this2.listener = new TestListener('111', _this2.state, _this2.msgToState);
    console.log('listener: ' + _this2.listener);
    return _this2;
  }

  _createClass(TestPage, [{
    key: "msgToState",
    value: function msgToState(message) {
      // console.log(message);
      var messages = this.state.messages;
      var msgs = messages;
      msgs.push(message);
      this.setState({
        messages: msgs
      });
    }
  }, {
    key: "componentWillMount",
    value: function componentWillMount() {
      var _this3 = this;

      var notifier = _webNotify["default"];

      if (notifier && typeof notifier !== 'undefined') {
        notifier.subscribe(this.listener.room, this.listener);
      }

      _axios["default"].get('http://172.17.0.1/api/v1/apps/status-page/all/prod', {
        headers: {
          'STREAM': 'TRUE'
        }
      }).then(function (resp) {
        // console.log(resp);
        _this3.msgToState = _this3.msgToState.bind(_this3);
        var listener = new TestListener(resp.data['STREAM_ROOM'], _this3.state, _this3.msgToState);
        notifier.subscribe(resp.data['STREAM_ROOM'], listener);
      }); // console.log(notifier);

    }
  }, {
    key: "render",
    value: function render() {
      console.log(this.state);
      var messages = this.state.messages;
      return _react["default"].createElement("div", null, "Messages: ", _react["default"].createElement("br", null), this.state.messages, messages && messages.length > 0 && messages.map(function (item, index) {
        return _react["default"].createElement("p", {
          key: index
        }, item);
      }));
    }
  }]);

  return TestPage;
}(_react["default"].Component);

exports["default"] = TestPage;
